
/* Generated data (by glib-mkenums) */

/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <arrow-glib/arrow-glib.h>

/* enumerations from "error.h" */
GType
garrow_error_get_type(void)
{
  static GType etype = 0;
  if (G_UNLIKELY(etype == 0)) {
    static const GEnumValue values[] = {
      {GARROW_ERROR_OUT_OF_MEMORY, "GARROW_ERROR_OUT_OF_MEMORY", "out-of-memory"},
      {GARROW_ERROR_KEY, "GARROW_ERROR_KEY", "key"},
      {GARROW_ERROR_TYPE, "GARROW_ERROR_TYPE", "type"},
      {GARROW_ERROR_INVALID, "GARROW_ERROR_INVALID", "invalid"},
      {GARROW_ERROR_IO, "GARROW_ERROR_IO", "io"},
      {GARROW_ERROR_CAPACITY, "GARROW_ERROR_CAPACITY", "capacity"},
      {GARROW_ERROR_UNKNOWN, "GARROW_ERROR_UNKNOWN", "unknown"},
      {GARROW_ERROR_NOT_IMPLEMENTED, "GARROW_ERROR_NOT_IMPLEMENTED", "not-implemented"},
      {GARROW_ERROR_SERIALIZATION, "GARROW_ERROR_SERIALIZATION", "serialization"},
      {GARROW_ERROR_PYTHON, "GARROW_ERROR_PYTHON", "python"},
      {GARROW_ERROR_PLASMA_OBJECT_EXISTS, "GARROW_ERROR_PLASMA_OBJECT_EXISTS", "plasma-object-exists"},
      {GARROW_ERROR_PLASMA_OBJECT_NONEXISTENT, "GARROW_ERROR_PLASMA_OBJECT_NONEXISTENT", "plasma-object-nonexistent"},
      {GARROW_ERROR_PLASMA_STORE_FULL, "GARROW_ERROR_PLASMA_STORE_FULL", "plasma-store-full"},
      {GARROW_ERROR_PLASMA_OBJECT_ALREADY_SEALED, "GARROW_ERROR_PLASMA_OBJECT_ALREADY_SEALED", "plasma-object-already-sealed"},
      {0, NULL, NULL}
    };
    etype = g_enum_register_static(g_intern_static_string("GArrowError"), values);
  }
  return etype;
}

/* enumerations from "type.h" */
GType
garrow_type_get_type(void)
{
  static GType etype = 0;
  if (G_UNLIKELY(etype == 0)) {
    static const GEnumValue values[] = {
      {GARROW_TYPE_NA, "GARROW_TYPE_NA", "na"},
      {GARROW_TYPE_BOOLEAN, "GARROW_TYPE_BOOLEAN", "boolean"},
      {GARROW_TYPE_UINT8, "GARROW_TYPE_UINT8", "uint8"},
      {GARROW_TYPE_INT8, "GARROW_TYPE_INT8", "int8"},
      {GARROW_TYPE_UINT16, "GARROW_TYPE_UINT16", "uint16"},
      {GARROW_TYPE_INT16, "GARROW_TYPE_INT16", "int16"},
      {GARROW_TYPE_UINT32, "GARROW_TYPE_UINT32", "uint32"},
      {GARROW_TYPE_INT32, "GARROW_TYPE_INT32", "int32"},
      {GARROW_TYPE_UINT64, "GARROW_TYPE_UINT64", "uint64"},
      {GARROW_TYPE_INT64, "GARROW_TYPE_INT64", "int64"},
      {GARROW_TYPE_HALF_FLOAT, "GARROW_TYPE_HALF_FLOAT", "half-float"},
      {GARROW_TYPE_FLOAT, "GARROW_TYPE_FLOAT", "float"},
      {GARROW_TYPE_DOUBLE, "GARROW_TYPE_DOUBLE", "double"},
      {GARROW_TYPE_STRING, "GARROW_TYPE_STRING", "string"},
      {GARROW_TYPE_BINARY, "GARROW_TYPE_BINARY", "binary"},
      {GARROW_TYPE_DATE32, "GARROW_TYPE_DATE32", "date32"},
      {GARROW_TYPE_DATE64, "GARROW_TYPE_DATE64", "date64"},
      {GARROW_TYPE_TIMESTAMP, "GARROW_TYPE_TIMESTAMP", "timestamp"},
      {GARROW_TYPE_TIME32, "GARROW_TYPE_TIME32", "time32"},
      {GARROW_TYPE_TIME64, "GARROW_TYPE_TIME64", "time64"},
      {GARROW_TYPE_INTERVAL, "GARROW_TYPE_INTERVAL", "interval"},
      {GARROW_TYPE_DECIMAL, "GARROW_TYPE_DECIMAL", "decimal"},
      {GARROW_TYPE_LIST, "GARROW_TYPE_LIST", "list"},
      {GARROW_TYPE_STRUCT, "GARROW_TYPE_STRUCT", "struct"},
      {GARROW_TYPE_UNION, "GARROW_TYPE_UNION", "union"},
      {GARROW_TYPE_DICTIONARY, "GARROW_TYPE_DICTIONARY", "dictionary"},
      {0, NULL, NULL}
    };
    etype = g_enum_register_static(g_intern_static_string("GArrowType"), values);
  }
  return etype;
}
GType
garrow_time_unit_get_type(void)
{
  static GType etype = 0;
  if (G_UNLIKELY(etype == 0)) {
    static const GEnumValue values[] = {
      {GARROW_TIME_UNIT_SECOND, "GARROW_TIME_UNIT_SECOND", "second"},
      {GARROW_TIME_UNIT_MILLI, "GARROW_TIME_UNIT_MILLI", "milli"},
      {GARROW_TIME_UNIT_MICRO, "GARROW_TIME_UNIT_MICRO", "micro"},
      {GARROW_TIME_UNIT_NANO, "GARROW_TIME_UNIT_NANO", "nano"},
      {0, NULL, NULL}
    };
    etype = g_enum_register_static(g_intern_static_string("GArrowTimeUnit"), values);
  }
  return etype;
}

/* enumerations from "file-mode.h" */
GType
garrow_file_mode_get_type(void)
{
  static GType etype = 0;
  if (G_UNLIKELY(etype == 0)) {
    static const GEnumValue values[] = {
      {GARROW_FILE_MODE_READ, "GARROW_FILE_MODE_READ", "read"},
      {GARROW_FILE_MODE_WRITE, "GARROW_FILE_MODE_WRITE", "write"},
      {GARROW_FILE_MODE_READWRITE, "GARROW_FILE_MODE_READWRITE", "readwrite"},
      {0, NULL, NULL}
    };
    etype = g_enum_register_static(g_intern_static_string("GArrowFileMode"), values);
  }
  return etype;
}

/* enumerations from "metadata-version.h" */
GType
garrow_metadata_version_get_type(void)
{
  static GType etype = 0;
  if (G_UNLIKELY(etype == 0)) {
    static const GEnumValue values[] = {
      {GARROW_METADATA_VERSION_V1, "GARROW_METADATA_VERSION_V1", "v1"},
      {GARROW_METADATA_VERSION_V2, "GARROW_METADATA_VERSION_V2", "v2"},
      {GARROW_METADATA_VERSION_V3, "GARROW_METADATA_VERSION_V3", "v3"},
      {0, NULL, NULL}
    };
    etype = g_enum_register_static(g_intern_static_string("GArrowMetadataVersion"), values);
  }
  return etype;
}

/* Generated data ends here */

