// Code generated by type_test.go.tmpl. DO NOT EDIT.

// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package math_test

import (
	"testing"

	"github.com/apache/arrow/go/arrow/array"
	"github.com/apache/arrow/go/arrow/math"
	"github.com/apache/arrow/go/arrow/memory"
	"github.com/stretchr/testify/assert"
)

func TestFloat64Funcs_Sum(t *testing.T) {
	vec := makeArrayFloat64(10000)
	res := math.Float64.Sum(vec)
	assert.Equal(t, res, float64(49995000))
}

func makeArrayFloat64(l int) *array.Float64 {
	fb := array.NewFloat64Builder(memory.NewGoAllocator())
	fb.Reserve(l)
	for i := 0; i < l; i++ {
		fb.Append(float64(i))
	}
	return fb.NewFloat64Array()
}

func benchmarkFloat64Funcs_Sum(b *testing.B, n int) {
	vec := makeArrayFloat64(n)
	b.SetBytes(int64(vec.Len() * 8))
	b.ResetTimer()
	for i := 0; i < b.N; i++ {
		math.Float64.Sum(vec)
	}
}

func BenchmarkFloat64Funcs_Sum_256(b *testing.B) {
	benchmarkFloat64Funcs_Sum(b, 256)
}

func BenchmarkFloat64Funcs_Sum_1024(b *testing.B) {
	benchmarkFloat64Funcs_Sum(b, 1024)
}

func BenchmarkFloat64Funcs_Sum_8192(b *testing.B) {
	benchmarkFloat64Funcs_Sum(b, 8192)
}

func BenchmarkFloat64Funcs_Sum_1000000(b *testing.B) {
	benchmarkFloat64Funcs_Sum(b, 1e6)
}
